# Handling Withdrawals

### Phase 1: Receiving Withdrawal Request from a User

![](https://3965312054-files.gitbook.io/~/files/v0/b/gitbook-legacy-files/o/assets%2F-MP899VqAdyGFgLTy9SY%2F-MYOkFgvFCy9g6b4gUrk%2F-MYOoTt6Igy6Kn0QQbln%2FUntitled%20presentation\(6\).jpg?alt=media\&token=7a14ebc1-2b9c-4278-9784-3805cffaf0f1)

#### Step 1

The user should send a withdrawal request to the server. The withdrawal request should have the currency and amount being transferred.

```javascript
// Express post endpoint to receive deposit requests
app.post(
    '/plugins/bank/withdrawal',
    toolsLib.security.verifyBearerTokenExpressMiddleware(['user']),
    (req, res) => {
        ...
    }
);
```

#### Step 2

The server creates a pending burn transaction for this specific withdrawal. This will lock the amount being withdrawn in the user's balance. This ensures that this amount will not be used during this withdrawal process. The `transaction_id` of the pending burn is required for phase 3 of this process.

```javascript
const amount, currency, BANK_ACCOUNT = // withdrawal data from request
const user_id = // ID of user making request

// Create a pending burn and save response
const pendingBurn = await toolsLib.wallet.burnAssetByKitId(
    user_id, // User kit id
    currency, // currency
    amount, // amount
    {
        status: false, // status false will make this burn pending
        description: 'Bank Deposit', // description
        transactionId: transaction_id // transaction id
    }
);
```

### Phase 2: Payment service attempts withdrawal to user's bank account

![](https://3965312054-files.gitbook.io/~/files/v0/b/gitbook-legacy-files/o/assets%2F-MP899VqAdyGFgLTy9SY%2F-MYOkFgvFCy9g6b4gUrk%2F-MYOqazyZmK9T9LbMTJz%2FUntitled%20presentation\(8\).jpg?alt=media\&token=0e20e985-b15f-49fc-8364-00b76f0fba50)

#### Step 1

The server makes a withdrawal request using the payment service.

{% hint style="warning" %}
This step will differ based on which payment service is used.
{% endhint %}

```javascript
const library = PAYMENT_SERVICE_SDK_LIBRARY; // Payment service sdk
const amount, currency = // withdrawal data from request
BANK_ACCOUNT; // user's bank account to withdrawal to

// Withdrawal method for payment service sdk
library.withdrawal(amount, currency, BANK_ACCOUNT);
```

#### Step 2

Payment service attempts to make the withdrawal to the user's bank account.

#### Step 3

Payment service responds to server with the withdrawal's status.

```javascript
// Withdrawal method for payment service sdk
library.withdrawal(amount, currency, USER_BANK_ACCOUNT)
    .then((data) => {
        // data contains status of the withdrawal
    })
    .catch((err) => {
        // withdrawal request failed
    });
```

### Phase 3: Server updates status of pending burn

![](https://3965312054-files.gitbook.io/~/files/v0/b/gitbook-legacy-files/o/assets%2F-MP899VqAdyGFgLTy9SY%2F-MYOkFgvFCy9g6b4gUrk%2F-MYOtejOE5alRV0UWtHo%2FUntitled%20presentation\(9\).jpg?alt=media\&token=dccadce1-9f2a-4827-a5f3-9ef5e6077634)

#### Step 1

The server updates the status of the pending burn created in phase 2 based on response from payment service.

```javascript
// Withdrawal method for payment service sdk
library.withdrawal(amount, currency, USER_BANK_ACCOUNT)
    .then((data) => {
        if (data.successful) {
            // If the withdrawal was successful
            toolsLib.wallet.updatePendingBurn(
                pendingBurn.transaction_id, // transaction_id saved from phase 1
                {
                    status: true,
                    // Optional: Update burn's transaction id to match 
                    // payment service withdrawal's transaction id
                    updatedTransactionId: data.transaction_id
                }
            );
        } else if (data.failed) {
            // If the withdrawal failed
            toolsLib.wallet.updatePendingBurn(
                pendingBurn.transaction_id, // transaction_id saved from phase 1
                {
                    rejected: true
                }
            );
        }
    })
    .catch((err) => {
        // withdrawal request failed
        toolsLib.wallet.updatePendingBurn(
            pendingBurn.transaction_id, // transaction_id saved from phase 1
            {
                rejected: true
            }
        );
    });
```

#### Step 2

Once the pending burn's status is updated, the locked amount on the user's balance will be unlocked. If the withdrawal was successful, the user's locked amount will be removed entirely from the total balance. If the withdrawal was unsuccessful, the locked amount will return to the user's total balance.

## Code Example

{% hint style="warning" %}
For this example, we are using a placeholder payment service sdk called `PAYMENT_SERVICE_SDK_LIBRARY`. The withdrawal step will differ based on the payment service used. Regardless, the overall flow of this process should be relatively the same.
{% endhint %}

```javascript
app.post(
    '/plugins/bank/withdrawal',
    toolsLib.security.verifyBearerTokenExpressMiddleware(['user']),
    async (req, res) => {
        const { currency, amount, bank_account } = req.body;
        const user_id = req.auth.sub.id;
        
        const pendingBurn = await toolsLib.wallet.burnAssetByKitId(
            user_id, // User kit id
            currency, // currency
            amount, // amount
            {
                status: false, // status false will make this burn pending
                description: 'Bank Withdrawal', // description
                transactionId: transaction_id // transaction id
            }
        );

        const library = PAYMENT_SERVICE_SDK_LIBRARY; // Payment service sdk
        const amount, currency = // withdrawal data from request

        // Withdrawal method for payment service sdk
        await library.withdrawal(amount, currency, bank_account)
            .then((data) => {
                if (data.successful) {
                    // If the withdrawal was successful
                    return toolsLib.wallet.updatePendingBurn(
                        pendingBurn.transaction_id, // transaction_id saved from phase 1
                        {
                            status: true,
                            // Optional: Update burn's transaction id to match 
                            // payment service withdrawal's transaction id
                            updatedTransactionId: data.transaction_id
                        }
                    );
                } else if (data.failed) {
                    // If the withdrawal failed
                    return toolsLib.wallet.updatePendingBurn(
                        pendingBurn.transaction_id, // transaction_id saved from phase 1
                        { rejected: true }
                    );
                }
            })
            .catch((err) => {
                // withdrawal request failed
                return toolsLib.wallet.updatePendingBurn(
                    pendingBurn.transaction_id, // transaction_id saved from phase 1
                    { rejected: true }
                );
            });
});
```

## Advanced

Although bank withdrawals can be handled one by one like above, we generally recommend withdrawals to be batched in intervals. You can do this by using a cron job that runs every five minutes or so. Every time the job runs, it will query all pending burns in the database, batch them by currency, and make a single withdrawal per currency to the payment service. This will lower the amount of calls being made.&#x20;


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hollaex.com/plugins/bank-integration/handling-withdrawals.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
